#!/usr/bin/env roundup

describe toru-path
. ./test-common.sh

it_displays_help() {
	LC_ALL=C toru-path -h >$tmpdir/stdout 2>$tmpdir/stderr

	[[ "$(sed 1q $tmpdir/stdout)" =~ Usage:.* ]]
	empty $tmpdir/stderr
}

it_runs() {
	mkdir -p "$XDG_CONFIG_HOME"/libretools
	printf 'TORUPATH=%q\n' "$tmpdir" >> "$XDG_CONFIG_HOME"/libretools/libretools.conf
	echo 'REPOS=(libre)' >> "$XDG_CONFIG_HOME"/libretools/libretools.conf
	printf 'ABSROOT=%q\n' "$PWD/toru.d" >> "$HOME"/.abs.conf

	toru-path

	tcamgr list "$tmpdir/paths.tch"|LC_COLLATE=C sort|while read -r key; do
		val="$(tcamgr get "$tmpdir/paths.tch" "$key")"
		printf '«%q» -> «%q»\n' "$key" "$val"
	done > "$tmpdir/paths-actual.txt"

	printf '«%q» -> «%q»\n' \
	       BAR "$PWD/toru.d/libre/split-base" \
	       BAZ "$PWD/toru.d/libre/split-base" \
	       FOO "$PWD/toru.d/libre/split-base" \
	       bar "$PWD/toru.d/libre/split" \
	       baz "$PWD/toru.d/libre/split" \
	       foo "$PWD/toru.d/libre/split" \
	       simple "$PWD/toru.d/libre/simple" \
	       split-base "$PWD/toru.d/libre/split-base" \
	       > "$tmpdir/paths-expected.txt"

	diff "$tmpdir/paths-expected.txt" "$tmpdir/paths-actual.txt"
}

it_sets_torupath() {
	mkdir -p "$XDG_CONFIG_HOME"/libretools
	printf 'TORUPATH=%q\n' "$tmpdir" >> "$XDG_CONFIG_HOME"/libretools/libretools.conf
	echo 'REPOS=(libre)' >> "$XDG_CONFIG_HOME"/libretools/libretools.conf
	printf 'ABSROOT=%q\n' "$PWD/toru.d" >> "$HOME"/.abs.conf

	mkdir -p "$tmpdir/x"
	T="$tmpdir/x" toru-path
	test -f "$tmpdir/x/paths.tch"
	not test -e "$tmpdir/paths.tch"
}
